//Source: http://www.dsptutor.freeuk.com/index.htm
#include "FastFourierTransform.h"
#include <cstdlib>
#include <math.h>

int FastFourierTransform::bitrev(int j) 
{

	int j2;
	int j1 = j;
	int k = 0;
	for (int i = 1; i <= nu; i++) 
	{
		j2 = j1/2;
		k  = 2*k + j1 - 2*j2;
		j1 = j2;
	}
	return k;
}

float* FastFourierTransform::fftMag(float* x,int xlen) 
{
	// assume n is a power of 2
	n = xlen;
	nu = (int)(log(n)/log(2));
	int n2 = n/2;
	int nu1 = nu - 1;

	float* xre = (float*)malloc(n*sizeof(float));
	float* xim = (float*)malloc(n*sizeof(float));
	float* mag = (float*)malloc(n2*sizeof(float));

	float tr;
	float ti;
	float p;
	float arg;
	float c;
	float s;

	for (int i = 0; i < n; i++) 
	{
      		xre[i] = x[i];
		xim[i] = 0.0f;
	}

	int k = 0;

	for (int l = 1; l <= nu; l++) 
	{
		while (k < n) 
		{
        		for (int i = 1; i <= n2; i++) 
			{
          			p = bitrev (k >> nu1);
				arg = 2 * (float)(3.1415926535897) * p / n;
				c = (float) cos (arg);
          			s = (float) sin (arg);
          			tr = xre[k+n2]*c + xim[k+n2]*s;
          			ti = xim[k+n2]*c - xre[k+n2]*s;
          			xre[k+n2] = xre[k] - tr;
				xim[k+n2] = xim[k] - ti;
				xre[k] += tr;
				xim[k] += ti;
				k++;
			}
			k += n2;
		}
		k = 0;
		nu1--;
		n2 = n2/2;
	}

	k = 0;
	int r;

	while (k < n) 
	{
		r = bitrev (k);
		if (r > k) 
		{
			tr = xre[k];
			ti = xim[k];
			xre[k] = xre[r];
			xim[k] = xim[r];
			xre[r] = tr;
			xim[r] = ti;
		}
		k++;
	}
    
    	// FIXME:
    	// also calculate frequency and phase information here

	mag[0] = (float) (sqrt(xre[0]*xre[0] + xim[0]*xim[0]))/n;
	for (int i = 1; i < n/2; i++)
	{
      		mag[i]= 2 * (float) (sqrt(xre[i]*xre[i] + xim[i]*xim[i]))/n;
	}
	free(xre);
	free(xim);
    	return mag;
}
