//WaveBuilder.java
//Resample a wave to the target frequency
// This is a static helper class for the Analysis class
//
//(c) 2005 David Cuny
//http://tunafish.sourceforge.net
//Released under Qt Public License
#ifndef __wavebuilder_h__
#define __wavebuilder_h__
#include "config.h"
class WaveBuilder 
{
public:
	static const int USE_CATMULL_CLARK = 0;
	static const int USE_CUBIC_SPLINE = 1;
	static const int USE_PSOLA = 2;
	
	int interpolation;// = USE_CATMULL_CLARK; 
	double catmullClarkSpline( double p0, double p1, double p2, double p3, float t );
	double cubicSpline( double p0, double p1, double p2, double p3, float t );	
	float getInterpolatedValue( float index, float* samples ,int sampleslen);
	int interpolateSingleWave( float* srcSamples, int srcSampleslen, int srcAt, int width, 
				   float* dstSamples, int dstSampleslen, int dstAt, double rate );
	
	float* resampleStream( float* samples, int sampleslen, float* frequency, double* targetMidi, int* waveWidth );
	
	// FIXME: this should be a single routine
//	int bytesToSample( byte* buffer, int bufferlen,int index, int bytesPerSample, int bitsPerSample );
	//int signedToUnsigned( int n );
//	int unsignedToSigned( int n );	
//	void samplesToBytes( int* samples, int sampleslen, byte* bytes, int bytesPerSample );
	WaveBuilder();
};

#endif
