// generated by Fast Light User Interface Designer (fluid) version 1.0107

#include "WavePanel.h"
#include "config.h"
#include "MainWindow.h"

void WaveCanvas::repaint() {
  this->damage();
this->redraw();
}

void WaveCanvas::init_window() {
  this->win=(Fl_Window*)make_window();
win->resize(this->parent()->x(),this->parent()->y(),this->parent()->w(),this->parent()->h());
this->currentCursor=FL_CURSOR_DEFAULT;
this->selectedSegment=NULL;
}

WaveCanvas::WaveCanvas(int a,int b,int c,int d):Fl_Group(a,b,c,d,NULL) {
  init_window();
}

Fl_Double_Window* WaveCanvas::make_window() {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = new Fl_Double_Window(395, 275, "wavecanvas");
    w = o;
    o->color((Fl_Color)53);
    o->selection_color((Fl_Color)53);
    o->labelsize(12);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP|FL_ALIGN_INSIDE);
    o->end();
  }
  return w;
}

int WaveCanvas::handle(int e) {
  /*char *fltk_eventnames[] =
{
  "FL_NO_EVENT",
  "FL_PUSH",
  "FL_RELEASE",
  "FL_ENTER",
  "FL_LEAVE",
  "FL_DRAG",
  "FL_FOCUS",
  "FL_UNFOCUS",
  "FL_KEYDOWN",
  "FL_KEYUP",
  "FL_CLOSE",
  "FL_MOVE",
  "FL_SHORTCUT",
  "FL_DEACTIVATE",
  "FL_ACTIVATE",
  "FL_HIDE",
  "FL_SHOW",
  "FL_PASTE",
  "FL_SELECTIONCLEAR",
  "FL_MOUSEWHEEL",
  "FL_DND_ENTER",
  "FL_DND_DRAG",
  "FL_DND_LEAVE",
  "FL_DND_RELEASE",
};

*/
this->whichbutton=0;
this->event_x=Fl::event_x();
this->event_y=Fl::event_y();
this->isShiftDown=Fl::event_state(FL_SHIFT);
if (Fl::event_state(FL_BUTTON1))
{
	this->whichbutton=1;
}
if (Fl::event_state(FL_BUTTON2)) 
{
	this->whichbutton=2;
}
if (Fl::event_state(FL_BUTTON3))
{
	this->whichbutton=3;
}
if (e==FL_MOVE) {
	mouseMoved();
	return 1;
}
if (e==FL_DRAG) {
	mouseDragged();
	return 1;
}
if (e==FL_PUSH) {
	mousePressed();
	return 1;
}
if (e==FL_RELEASE) {
	mouseReleased();
	if (Fl::event_is_click())
	{
		if (Fl::event_clicks()==0)
		{
			mouseClicked();
		}
		if (Fl::event_clicks()==1)
		{
			mouseDoubleClicked();
			Fl::event_clicks(0);
		}
	}
	return 1;
}
// TODO: How to detect mouse clicked?
if (e==FL_ENTER) {
	mouseEntered();
	return 1;
}

if (e==FL_LEAVE) {
	mouseExited();
	return 1;
}

return 1;
}

void WaveCanvas::mouseMoved() {
  this->adjustCursor( this->event_x, this->event_y, this->isShiftDown );
}

void WaveCanvas::mouseDragged() {
  if (wavePanel->wave==NULL) return;
int x = event_x;
int y = event_y;

// get offset
int position = wavePanel->horizontalScrollBar->value();
			
// actual position
float zoom = wavePanel->wave->zoom;
int at = (int)((position + x-MARGIN)*zoom);

// is a segment being dragged?
if (this->selectedSegment != NULL) {
	// calculate change in y position
	int dy = y - this->mouseDragStartY;

	// calculate relative change in terms of midi notes
	int addMidi = dy / wavePanel->wave->SEGMENT_HEIGHT;

	// moved less than a step?
	if (addMidi == 0) {
		// only change the position of the drag box
		this->selectedSegment->dragY = dy;
		
	} else {
		// reset the drag offset
		this->selectedSegment->dragY = 0;					
		this->mouseDragStartY = y;
			
		// add to user changed midi value
		this->selectedSegment->midiNumber -= addMidi;
				
		// resample the wave
		wavePanel->wave->analyzeWave->calculateCorrectPitch();															
	}
				
	// repaint
	wavePanel->redraw();
				
	return;
			
}
			
	
// no start selection?
if (wavePanel->wave->selectionStart == -1 ) {
	// start selection here
	wavePanel->wave->selectionStart = at;
}
			
// extend the selection
wavePanel->wave->extendSelection( at );
			
// repaint
wavePanel->repaint();
}

void WaveCanvas::mousePressed() {
  //printf("press\n");
bool repaintFlag = false;

// get position
int x = event_x;
int y = event_y;

// get the wave handler
WaveHandler* wave = wavePanel->wave;

// deactivate prior segment?
if (this->selectedSegment != NULL) 
{
	// unselect the segment
	this->selectedSegment->isSelected = false;
	
	// force a repaint
	repaintFlag = true;
}

// hit a segment?
this->selectedSegment = wave->hitSegment( x, y,this->x(),this->y(), this->h());
if (this->selectedSegment != NULL) 
{				
	// make the selected segment active
	this->selectedSegment->isSelected = true;

	// save mouse position at the start of the drag
	this->mouseDragStartX = x;
	this->mouseDragStartY = y;
	
	// force a repaint
	repaintFlag = true;
	
} else {

	// remove selection?
	if (wavePanel->wave->selectionStart != -1 ) {				
		wavePanel->wave->selectionStart = -1;
		repaintFlag = true;
	}
}

// repaint window?
if (repaintFlag) {
	// update the window
	this->damage();
	wavePanel->damage();
	wavePanel->redraw();
}
}

void WaveCanvas::mouseReleased() {
  if (this->selectedSegment != NULL) 
{
	// clear the drag offset
	this->selectedSegment->dragY = 0;	
	// repaint
	this->wavePanel->redraw();
}
}

void WaveCanvas::mouseClicked() {
  //printf("Click\n");
// nothing
}

void WaveCanvas::mouseDoubleClicked() {
  //printf("doubleclick\n");
}

void WaveCanvas::mouseEntered() {
  //printf("enter\n");
this->currentCursor = FL_CURSOR_DEFAULT;

this->setCursor( this->currentCursor );
}

void WaveCanvas::mouseExited() {
  //printf("exit\n");
// restore the default cursor?
if (this->currentCursor != FL_CURSOR_DEFAULT) {
	this->currentCursor = FL_CURSOR_DEFAULT;
}
}

void WaveCanvas::draw() {
  if (wavePanel == NULL) 
{
	// no wave loaded yet? (instead, check wavehandler buffer len)
	return;
}
	    	
int points = 12;
				
// repaint
Fl_Group::draw(); //super.paintComponent(g);
			
// get size
int height = this->h();
int width = this->w();
fl_color(NON_SCALE_BACKGROUND);
fl_rectf(this->x(),this->y(),this->w(),this->h());


int position=this->wavePanel->horizontalScrollBar->value();

this->wavePanel->wave->render(this->x(),this->y(),width,height, position);
}

void WaveCanvas::useCursor(int id) {
  if (this->currentCursor != id) {
	// make it current
	this->currentCursor = id;
	// use it
	this->setCursor( id );
}
}

void WaveCanvas::setCursor(int id) {
  printf("TODO: WaveCanvas::usecursor");
}

void WaveCanvas::adjustCursor(int x,int y,bool isShiftDown) {
  //useCursor(Cursor.<TYPE>)
}

void WaveCanvas::Panel(WavePanel* panel) {
  wavePanel=panel;
}

void WavePanel::cb_verticalScrollBar_i(Fl_Scrollbar*, void*) {
  waveCanvas->repaint();
}
void WavePanel::cb_verticalScrollBar(Fl_Scrollbar* o, void* v) {
  ((WavePanel*)(o->parent()->parent()->parent()->user_data()))->cb_verticalScrollBar_i(o,v);
}

void WavePanel::cb_horizontalScrollBar_i(Fl_Scrollbar*, void*) {
  waveCanvas->repaint();
}
void WavePanel::cb_horizontalScrollBar(Fl_Scrollbar* o, void* v) {
  ((WavePanel*)(o->parent()->parent()->parent()->user_data()))->cb_horizontalScrollBar_i(o,v);
}

#include <FL/Fl_Pixmap.H>
static const char *idata_resizethumb[] = {
"18 18 -3 1",
"!\253\246\230\"\352\350\343#\377\377\377",
"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"",
"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"",
"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"",
"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"#\"",
"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"#!\"",
"\"\"\"\"\"\"\"\"\"\"\"\"\"\"#!!\"",
"\"\"\"\"\"\"\"\"\"\"\"\"\"#!!\"\"",
"\"\"\"\"\"\"\"\"\"\"\"\"#!!\"\"\"",
"\"\"\"\"\"\"\"\"\"\"\"#!!\"\"#\"",
"\"\"\"\"\"\"\"\"\"\"#!!\"\"#!\"",
"\"\"\"\"\"\"\"\"\"#!!\"\"#!!\"",
"\"\"\"\"\"\"\"\"#!!\"\"#!!\"\"",
"\"\"\"\"\"\"\"#!!\"\"#!!\"\"\"",
"\"\"\"\"\"\"#!!\"\"#!!\"\"#\"",
"\"\"\"\"\"#!!\"\"#!!\"\"#!\"",
"\"\"\"\"#!!\"\"#!!\"\"#!!\"",
"\"\"\"#!!\"\"#!!\"\"#!!\"\"",
"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\"\""
};
static Fl_Pixmap image_resizethumb(idata_resizethumb);

void WavePanel::init_window() {
  this->win=(Fl_Window*)make_window();
win->resize(this->parent()->x(),this->parent()->y(),this->parent()->w(),this->parent()->h());
this->wave=new WaveHandler();


this->baseMidi=0;
this->selectedSegment=NULL;
}

WavePanel::WavePanel(int a,int b,int c,int d):Fl_Group(a,b,c,d,NULL) {
  init_window();
}

void WavePanel::repaint() {
  this->damage();
this->redraw();
//printf("TODO: WavePanel::repaint()\n");
}

void WavePanel::adjustScrollbar() {
  int max=(wave->sfinfoin->frames);/* /(wave->zoom) ; */
this->horizontalScrollBar->maximum(max);
}

Fl_Group* WavePanel::make_window() {
  Fl_Group* w;
  { Fl_Group* o = panel = new Fl_Group(0, 0, 645, 435);
    w = o;
    o->box(FL_FLAT_BOX);
    o->color(FL_BACKGROUND_COLOR);
    o->selection_color(FL_BACKGROUND_COLOR);
    o->labeltype(FL_NO_LABEL);
    o->labelfont(0);
    o->labelsize(14);
    o->labelcolor(FL_FOREGROUND_COLOR);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_TOP);
    o->when(FL_WHEN_RELEASE);
    { Fl_Group* o = wavepanelvstretch = new Fl_Group(0, 0, 645, 417);
      { Fl_Group* o = wavecanvascontainer = new Fl_Group(0, 0, 627, 417);
        o->color((Fl_Color)53);
        o->selection_color((Fl_Color)53);
        { WaveCanvas* o = wavecanvasobject = new WaveCanvas(0, 0, 627, 417);
          o->box(FL_NO_BOX);
          o->color((Fl_Color)53);
          o->selection_color((Fl_Color)53);
          o->labeltype(FL_NORMAL_LABEL);
          o->labelfont(0);
          o->labelsize(12);
          o->labelcolor(FL_FOREGROUND_COLOR);
          o->align(FL_ALIGN_TOP);
          o->when(FL_WHEN_RELEASE);
          waveCanvas=o; waveCanvas->Panel(this);
          o->end();
        }
        o->end();
        Fl_Group::current()->resizable(o);
      }
      { Fl_Group* o = new Fl_Group(627, 0, 18, 417);
        { Fl_Scrollbar* o = verticalScrollBar = new Fl_Scrollbar(627, 0, 18, 417);
          o->color((Fl_Color)53);
          o->selection_color((Fl_Color)51);
          o->labelsize(12);
          o->maximum(10000);
          o->callback((Fl_Callback*)cb_verticalScrollBar);
        }
        o->end();
      }
      o->end();
      Fl_Group::current()->resizable(o);
    }
    { Fl_Group* o = new Fl_Group(0, 417, 648, 18);
      { Fl_Group* o = wavepanelhstretch = new Fl_Group(0, 417, 648, 18);
        { Fl_Scrollbar* o = horizontalScrollBar = new Fl_Scrollbar(0, 417, 627, 18);
          o->type(1);
          o->color((Fl_Color)53);
          o->selection_color((Fl_Color)51);
          o->labelsize(12);
          o->maximum(10000);
          o->callback((Fl_Callback*)cb_horizontalScrollBar);
          Fl_Group::current()->resizable(o);
        }
        { Fl_Group* o = wavepanelfixed = new Fl_Group(627, 417, 18, 18);
          o->image(image_resizethumb);
          o->align(FL_ALIGN_TOP|FL_ALIGN_INSIDE);
          o->end();
        }
        o->end();
      }
      o->end();
    }
    o->end();
  }
  return w;
}
