#include "WaveHandler.h"
#include "WaveSegment.h"

WaveSegment::WaveSegment( int start, int end, int midi, float* samples,int sampleslen ) 
{
	this->startSample = start;
	this->endSample = end;		
	this->midiNumber = midi;
	this->selected = false;
	this->overrideScale = false;
	this->isSelected=false;
	this->x1=0;	
	this->y1=0;
	this->x2=0;
	this->y2=0;
	this->dragY=0;
	// find the maximum height
	this->maxHeight = 1;
	for (int i = startSample; i <= endSample; i++) 
	{
		float sample = samples[i];
		if (sample<0) sample=-sample;			
		if (sample > this->maxHeight) this->maxHeight = sample;
	}
}

void WaveSegment::calcScreenPosition( int xStart, int yStart, double zoom,WaveHandler* wave ) 
{
	this->x1 = xStart;
	this->y1 = yStart - (wave->SEGMENT_HEIGHT/2);
	this->x2 = x1 + (int)((this->endSample - this->startSample) / zoom);
	this->y2 = y1 + wave->SEGMENT_HEIGHT;
	
}
	
void WaveSegment::render( int xStart, int yStart, double zoom, WaveHandler* wave,float* samples,int sampleslen,int waveOffset) 
{

	// calculate screen position
	this->calcScreenPosition( xStart, yStart, zoom,wave);
				
	// selected?
	if (this->isSelected) {
		fl_color(SELECTED_SEGMENT);
	} else {
		fl_color(UNSELECTED_SEGMENT);
	}
	fl_rectf( this->x1-(waveOffset/zoom), this->y1, 1+this->x2 - this->x1,1+ this->y2 - this->y1);
			
	// draw selection box?
	if (this->isSelected) {
		fl_color(SELECTED_SEGMENT_BORDER);
	} else {
		fl_color(UNSELECTED_SEGMENT_BORDER);
	}
	// draw selection box, offset by dragY value
	fl_rect( this->x1-(waveOffset/zoom), this->y1+this->dragY, 1+this->x2 - this->x1,1+ this->y2 - this->y1);
}

	
