#ifndef __wavepanel__h_
#define __wavepanel__h_

#include <FL/Fl_Group.H>
#include "WaveHandler.h"
#include "WaveSegment.h"

#define MouseEvent void*
#define Graphics void*

class WaveCanvas : public Fl_Group
{
private:
	int currentCursor;// = Cursor.DEFAULT_CURSOR;

	// position dragging began
	int mouseDragStartX;
	int mouseDragStartY;
	
	// midi value before drag
	int baseMidi;
		
	// active segment (if any)
	void useCursor( int id );
	WaveSegment* selectedSegment;
	void init();
public:
	WaveCanvas();
	void repaint();
	void paintComponent(/*Graphics*/void* g);   
	void adjustCursor( int x, int y, bool isShiftDown );
	void mouseMoved(MouseEvent e);
	void mouseDragged(MouseEvent e);
	void mousePressed(MouseEvent e);
	void mouseClicked(MouseEvent e);
	void mouseReleased(MouseEvent e);
	void mouseEntered(MouseEvent e);
	void mouseExited(MouseEvent e);
}; 

class WavePanel:Fl_Group {

private: 
	static const long serialVersionUID = 1L;
public:	
	void repaint();
	WaveHandler* wave;
	WaveCanvas* waveCanvas;
	//JScrollBar horizontalScrollBar;
//	public JScrollBar verticalScrollBar;
	
	WavePanel(int pixels);
	void adjustScrollbar();
};


#endif
