//pitchfork.cpp
//Ported from the Java application (c)2005 by David Cuny
//(c) 2008 Marc Brevoort
//http://yolo.sourceforge.net
//Released under Qt Public License
using namespace std;
#include <iostream>
#include <vector>
#include <string>
#define MAINDEBUG 0
#define LINUX 1
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include "MainWindow.h"
#include <FL/x.H> 
#ifdef LINUX
#include <X11/xpm.h> 
#endif
//#include "images/hd24connect.xpm" 
#include <iostream>
#include <string>
#include <stdlib.h>
#ifndef MAX_PATH
#define MAX_PATH 127
#endif

#ifdef WINDOWS
#include <windows.h>
#define IDI_ICON1 101 
#endif

int main(int argc,char **argv)
{
#ifdef LINUX
	fl_open_display();
#endif
	UserInterface ui;
	Fl_Window *window=NULL;
	window=ui.make_window();
#ifdef WINDOWS
	if (window!=NULL) 
	{
		window->icon((char *)LoadIcon(fl_display,MAKEINTRESOURCE(IDI_ICON1)));
        	window->end();   
        	window->show(); //argc, argv);
	}
#endif   
#ifdef LINUX 
	if (window!=NULL)
	{
        	window->end();
        	window->show(); //argc, argv);
	}
        	Pixmap p, mask;
/*        XpmCreatePixmapFromData(fl_display,DefaultRootWindow(fl_display),(char 
**)hd24connect_xpm, &p, &mask, NULL); */

/*
 * FLTK support for transparent background is broken. So instead of this:
 * window->icon((char *)p);
 * We will write the following: */
	XWMHints *hints=NULL;
	if (window!=NULL)
	{
		hints = XGetWMHints(fl_display, fl_xid(window));
		hints->icon_pixmap = p;
		hints->icon_mask = mask;
		hints->flags = IconPixmapHint | IconMaskHint;
		XSetWMHints(fl_display, fl_xid(window), hints);
	}
/* -- end of transparency fix */  
#endif
	int result;
	if (window!=NULL)
	{
		result= Fl::run();
	}
        cout << "Thank you for using pitchfork." << endl;
        if (hints!=NULL)
        {
                delete hints;
        }
        return result;
}
