#include "utils.h"
bool utils::fileExists(const char* strFilename) {
	struct stat stFileInfo;
 	int intStat;

	// Attempt to get the file attributes
	intStat = stat(strFilename,&stFileInfo);
	if(intStat == 0) 
	{
		// We were able to get the file attributes
		// so the file obviously exists.
		return true;
	}
	// We were not able to get the file attributes.
	// This may mean that we don't have permission to
	// access the folder which contains this file. If you
	// need to do that level of checking, lookup the
	// return values of stat which will give you
	// more details on why stat failed.
	return false;
}
bool utils::dirExists(const char * pszDirName)
{
#ifdef WIN32
    unsigned int dwAttrs;
    if (!(pszDirName))
    {
      //setupLog(NULL, "DirExists failed: passed in NULL parameter for directory");
      return (1==0);
    }
    dwAttrs = GetFileAttributes(pszDirName);
    if ((dwAttrs != 0xFFFFFFFF) && (dwAttrs & FILE_ATTRIBUTE_DIRECTORY))
    {
      return (1==1);
    }
    return (1==0);
#else
    struct stat fi;

    if (stat (pszDirName, &fi) == -1 || !S_ISDIR(fi.st_mode))
    {
      return (1==0);
    }
    else
    {
      return (1==1);
    }
#endif
}
string* utils::getlastdir(string which)
{
	string* whichdir;
	char buffer[FL_PATH_MAX];

	Fl_Preferences* userprefs=new Fl_Preferences(Fl_Preferences::USER, "mrjb","PitchFork" );
	/* Attempt to find last used project dir */
	if (userprefs->entryExists(which.c_str())) {
		userprefs->get(which.c_str(),buffer,".",FL_PATH_MAX);
		whichdir=new string(buffer);
	} else {
	        whichdir=new string(".");
	}
	delete userprefs;
	return whichdir;
}

void utils::setlastdir(string which,const char* newdir)
{
	Fl_Preferences* userprefs=new Fl_Preferences(Fl_Preferences::USER, "mrjb","PitchFork" );
	userprefs->set(which.c_str(),newdir);
	// cout << "just set " << which << " to " << newdir << endl;
	delete userprefs;
}
